#ifndef _DOWNLOADER_H 
#define _DOWNLOADER_H

#include "Global_ds.h"
#include "Parser.h"


#ifdef _WIN32							// Windows

#include <winsock2.h>

void sleep(unsigned sec);

#else									// Unix/Linux

#include <netdb.h>

typedef int SOCKET;

#endif

/* Macro definitions */
/* ----------------- */

#define BUFFER_SIZE 1024
#define SYSTEM_COMMAND_SIZE 256

/* library functions */
/* ----------------- */

// Every DOWNLOAD_CYCLE hours perform the following:
// Download the zipped data file from URL, unzipp it,
// destroy the old trie tree, create and build the new trie tree,
// and sleep for the rest of the cycle.
// Note:	1)	the downloader thread manipulates the trie tree
//				only after locking the trie_locker.
//			2)	The trie_locker is unlocked when the thread is
//				done with the trie tree.
//			3)	The downloader terminates only after getting
//				the SIGTERM signal.
void* threadCyclicDownload(void*);


#endif	/* _DOWNLOADER_H */
