#include "List.h"

List *createList(int data, List *next)
{
    List *node = (List *)malloc(sizeof(List));

	if (node){
		node->data = data;
		node->next = next;
	}

    return node;
}

void freeList(List *head)
{
    List *ptr;

    while(head)
	{
        ptr = head;
        head = head->next;
		free(ptr);
    }
}

void insertList(List **head, const int data)
{
	List *new_head = createList(data, *head);

	if(new_head)
		*head = new_head;
}

List *copyList(List* original)
{
	List *copy = NULL;

	while(original)
	{
		insertList(&copy, original->data);
		original = original->next;
	}

	return copy;
}

void fprintList(FILE* output, const List *head)
{
	List* ptr = (List*)head;

	while(ptr){
		fprintf(output, "%d ", ptr->data);
		ptr = ptr->next;
	}

	fputc('\n', output);
}

List *findList(List *head, const int data)
{
    List *ptr = head;

    while(ptr && (ptr->data != data))
        ptr = ptr->next;

    return ptr;
}

int lengthList(const List *head)
{
    int counter;

    for(counter=0; head != NULL; head = head->next)
        ++counter;

    return counter;
}
